-- #############################################################################
-- # Calculated Capacity v2.0 - Lua application tested with DS16
-- #
-- # Copyright (c) 2018, Walter Loetscher
-- # All rights reserved.
-- #
-- # License: Share alike
-- # Can be used and changed non commercial
-- #
-- # v2.0 new version
-- #############################################################################
--------------------------------------------------------------------------------
collectgarbage()
-- Locals
local appName = "Calculated Capacity v2.0"
local acOptions = {"Electro LiPo", "Electro 4D", "Jet", "Jetstart", "Gas"}
local mfOptions = {"Yes", "No"}
local sAcType, sThrustControl, sCapacity, sAltCapacity, sThrust100, sThrust75, sThrust50, sThrust25, sThrust00
local sKnockOff, sBingo, sSafetySwitch, sResetSwitch, sAccuSwitch, sMultFlight = 2, sCheckRec, sReport sIntCap = 100
local oneSecond = false; actualTime = 0; t = {}                             -- t = Throttle 0-100 %
local start = true change = true electro = false datasValid = false
local throttle = 0 thrust = 0 addThrottle = 0 avgThrottle = 0 count = 1
local dispFuel = 100.0, actualFuel cellDec = 20 maxFuel = 100000 coe = 1.00
local state = 0                                                             -- 0 = stop 1 = idle 2 = running 3 = jetstart
local alarm50 = true alarm25 = true alarm20 = true
local alarm15 = true alarm10 = true sAltEn = 0
local alarmknockoff = true alarmbingo = true capacity = 0
local vrs, vss, vgs, acs, delay, idle
--------------------------------------------------------------------------------
-- Telemetry and Data Verification
local function printTelem()
	if throttle and (sCapacity > 0) and (sThrust100 > -1) then
	datasValid = true
	lcd.drawText(10,0,string.format("%s%%",dispFuel),FONT_MAXI)
	lcd.drawNumber(5,34,capacity,FONT_NORMAL)
	lcd.drawText(45,34,"mAh Capacity")	
	lcd.drawNumber(15,50,thrust,FONT_NORMAL)
	lcd.drawText(45,50,"%  Throttle")
	else
	lcd.drawText(10,10,"Missing Datas",FONT_NORMAL)
	end
end
--------------------------------------------------------------------------------
-- Save
local function atChanged(value)
sAcType=value
system.pSave("sAcType",value)
change = true
end
local function tcChanged(value)
sThrustControl=value
system.pSave("sThrustControl",value)
change = true
end
local function caChanged(value)
sCapacity=value
system.pSave("sCapacity",value)
change = true
end
local function acChanged(value)
sAltCapacity=value
system.pSave("sAltCapacity",value)
change = true
end
local function T100Changed(value)
sThrust100=value
system.pSave("sThrust100",value)
change = true
end
local function T75Changed(value)
sThrust75=value
system.pSave("sThrust75",value)
change = true
end
local function T50Changed(value)
sThrust50=value
system.pSave("sThrust50",value)
change = true
end
local function T25Changed(value)
sThrust25=value
system.pSave("sThrust25",value)
change = true
end
local function T00Changed(value)
sThrust00=value
system.pSave("sThrust00",value)
change = true
end
local function koChanged(value)
sKnockOff=value
system.pSave("sKnockOff",value)
end
local function biChanged(value)
sBingo=value
system.pSave("sBingo",value)
end
local function swChanged(value) -- 1=Safe, -1=Disarmed, 0=not set
sSafetySwitch=value
system.pSave("sSafetySwitch",value)
change = true
end
local function rsChanged(value) -- 0=Reset, -1=off
sResetSwitch=value
system.pSave("sResetSwitch",value)
change = true
end
local function rfChanged(value)
sReport=value
system.pSave("sReport",value)
change = true
end
local function mfChanged(value) -- 0=Reset, -1=off
sMultFlight=value
system.pSave("sMultFlight",value)
change = true
end
local function asChanged(value) -- 1=Safe, -1=Disarmed, 0=not set
sAccuSwitch=value
system.pSave("sAccuSwitch",value)
change = true
end
--------------------------------------------------------------------------------
-- Functions
local function resetAlarm()
	alarm50 = true
	alarm25 = true
	alarm20 = true
	alarm15 = true
	alarm10 = true
	alarmknockoff = true
	alarmbingo = true
end
local function calcOneSecond()
	oneSecond = false
	if system.getTimeCounter() >= actualTime +1000 then
	    oneSecond = true
		actualTime = system.getTimeCounter()
	end
end
local function getValues()		
	for i = 1, 100 do t[i] = nil end
	if sAltEn == 1 and sAltCapacity > 0 then capacity = sAltCapacity
	else capacity = sCapacity
	end	
	t[0] = math.floor(sThrust00 * 10000 / capacity / 3.6)
	t[25] = math.floor(sThrust25 * 10000 / capacity / 3.6)
	t[50] = math.floor(sThrust50 * 10000 / capacity / 3.6)
	t[75] = math.floor(sThrust75 * 10000 / capacity / 3.6)
	t[100] = math.floor(sThrust100 * 10000 / capacity / 3.6)
		if (sAcType == 1) or (sAcType == 2) then electro = true else electro = false end
end
local function initDatas()
	if sMultFlight == 1 then actualFuel = sIntCap * 1000	
	else
	actualFuel = maxFuel	
	end
	if sAcType == 4 then state = 5 end	
	start = false
end
local function checkSwitches()
	throttle = system.getInputsVal(sThrustControl)
	vss = system.getInputsVal(sSafetySwitch)
	vrs = system.getInputsVal(sResetSwitch)
	vgs = system.getInputsVal(sReport)
	acs = system.getInputsVal(sAccuSwitch)
		if vrs == 1 then 
		actualFuel = maxFuel 
		resetAlarm() 
		end
		if vgs == 1 then 
		delay = delay + 1
			if delay == 1 then system.playNumber(dispFuel, 0, "%") end
			if delay == 100 then delay = 0 end
		else
		delay = 0
		end
		if acs == 1 and sAltEn == 0 then sAltEn = 2 end
		if acs == -1 and sAltEn == 2 then sAltEn = 1 change = true system.pSave("sAltEn", sAltEn) end
		if acs == 1 and sAltEn == 1 then sAltEn = 3 end
		if acs == -1 and sAltEn == 3 then sAltEn = 0 change = true system.pSave("sAltEn", sAltEn) end
end
local function curve()
	if t[75] < 0 then
		if t[50] > -1 then t[75] = t[50]+((t[100]-t[50])//2)
			elseif t[25] > -1 then
				t[50] = ((t[100]-t[25])//3) + t[25]
				t[75] = t[100]-((t[100]-t[25])//3)
			else t[75] = t[100] - ((t[100] - t[0])//4)		
		end
	end
	if t[50] < 0 then
		if t[25] > -1 then t[50] = t[25]+((t[75]-t[25])//2)
			else t[50] = t[75] - ((t[75]-t[0])//3)
		end	
	end
	if t[25] < 0 then t[25] = t[0]+((t[50]-t[0])//2)	end
end
local function fill()
	local i = 1
	while i < 100 do
		if t[i] then i = i + 1
		else
			j = i + 1
			while not t[j] do
				j = j + 1
			end
			t[i] = t[(i-1)] + ((t[j] - t[(i-1)]) // (j-i+1))
		end 
	end
collectgarbage()
end
local function checkState()
	if vss == 1 and electro then state = 1
	elseif vss == 1 and sAcType == 4 then state = 3
	elseif vss == 1 and sAcType ~= 4 then state = 0
	end
	if vss ~= 1 then
		if state == 5 and throttle > 0.95 then state = 6 end
		if state == 6 and throttle < -0.95 then state = 3 end
		if state == 3 and throttle > 0.95 then state = 4 end
		if state == 4 and throttle < -0.95 then state = 2 end
		if state < 3 then state = 2 end
	end	
end
local function alarm()
	if (sBingo ~= 0) or (sKnockOff ~= 0) then
		if dispFuel <= 50 and alarm50 then
		system.playNumber(50, 0, "%")
		alarm50 = false
		end
		if dispFuel <= (sKnockOff) and alarmknockoff then
		system.playFile("CC_Knockoff.wav", AUDIO_BACKGROUND)
		alarmknockoff = false
		end
		if dispFuel <= (sBingo) and alarmbingo then
		system.playFile("CC_Bingo.wav", AUDIO_BACKGROUND)
		alarmbingo = false
		end
	else
	if dispFuel <= 50 and alarm50 then
		system.playNumber(50, 0, "%")
		alarm50 = false
	end
	if dispFuel <= 25 and alarm25 then
		system.playNumber(25, 0, "%")
		alarm25 = false
	end
	if dispFuel <= 20 and alarm20 then
		system.playNumber(20, 0, "%")
		alarm20 = false
	end
	if dispFuel <= 15 and alarm15 then
		system.playNumber(15, 0, "%")
		alarm15 = false
	end
	if dispFuel <= 10 and alarm10 then
		system.playNumber(10, 0, "%")
		alarm10 = false
	end
	end
end
--------------------------------------------------------------------------------
-- Debug
local function debug()	
	--print("Capacity =", capacity, "Fuel =", dispFuel)
end
--------------------------------------------------------------------------------
-- Loop
local function loop()
	if change == true then 
	getValues() curve() fill() 
		if sAcType == 2 then
		idle = 10						-- Idle Value for 4D
		else idle = t[0]
		end
	change = false 
	end
	if start then initDatas() end
	checkSwitches()	
	if throttle then
		checkState ()
		thrust = (throttle * 100 + 100) // 2
		calcOneSecond()
		if oneSecond then
			collectgarbage()
			avgThrottle = math.floor(addThrottle / count)
			if electro then
				coe = (100 - cellDec + cellDec * actualFuel / maxFuel) / 100
			end	
			if state == 2 then actualFuel = actualFuel - coe * t[avgThrottle]
			elseif state == 1 then actualFuel = actualFuel - coe * idle
			end
			dispFuel = (actualFuel // 100) / 10
			alarm()
			count = 0
			addThrottle = 0
			if sMultFlight == 1 
			then 
			system.pSave("sIntCap", dispFuel) 
			end
		else
			addThrottle = addThrottle + thrust
			count = count + 1
		end
	end
	debug()
end
--------------------------------------------------------------------------------
-- Form Initialization
local function initForm(subform)
	form.addLabel({label="  --> Mandatory Entrys <--", font=FONT_MINI})
	form.addRow(2)
	form.addLabel({label="Aircraft Type", font=FONT_BOLD})
	form.addSelectbox(acOptions, sAcType, false, atChanged, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Throttle Control", font=FONT_BOLD})
	form.addInputbox(sThrustControl,true,tcChanged, {font=FONT_BOLD})
	form.addLabel({label="  --> Set Proportional!", font=FONT_MINI})
	form.addRow(2)
	form.addLabel({label="Capacity mAh or mL", font=FONT_BOLD})
	form.addIntbox(sCapacity,0,10000,0,0,25,caChanged, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Throttle 100%", font=FONT_BOLD})
	form.addIntbox(sThrust100,-1,10000,0,1,1,T100Changed, {font=FONT_BOLD})
	form.addLabel({label="  --> Ampère or Liter per Hour", font=FONT_MINI})
	form.addLabel({label="___________________________________________________________"})
	form.addLabel({label="  --> Optional Entrys <--", font=FONT_MINI})
	form.addRow(2)
	form.addLabel({label="Throttle 75%", font=FONT_BOLD})
	form.addIntbox(sThrust75,-1,10000,0,1,1,T75Changed, {font=FONT_BOLD})
	form.addLabel({label="  --> -1 for Automatic Interpolation", font=FONT_MINI})
	form.addRow(2)
	form.addLabel({label="Throttle 50%", font=FONT_BOLD})
	form.addIntbox(sThrust50,-1,10000,0,1,1,T50Changed, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Throttle 25%", font=FONT_BOLD})
	form.addIntbox(sThrust25,-1,10000,0,1,1,T25Changed, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Throttle 0%", font=FONT_BOLD})
	form.addIntbox(sThrust00,0,10000,0,1,1,T00Changed, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Prewarning %", font=FONT_BOLD})
	form.addIntbox(sKnockOff,0,100,0,0,1,koChanged, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Warning (Bingo) %", font=FONT_BOLD})
	form.addIntbox(sBingo,0,100,0,0,1,biChanged, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Safety Switch", font=FONT_BOLD})
	form.addInputbox(sSafetySwitch,true,swChanged, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Reset Switch", font=FONT_BOLD})
	form.addInputbox(sResetSwitch,true,rsChanged, {font=FONT_BOLD})
	form.addLabel({label="  --> Toggle Switch recommended", font=FONT_MINI})
	form.addRow(2)
	form.addLabel({label="Report Actual Fuel", font=FONT_BOLD})
	form.addInputbox(sReport,true,rfChanged, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Multiple Flights?", font=FONT_BOLD})
	form.addSelectbox(mfOptions, sMultFlight, false, mfChanged, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Alternate Accu", font=FONT_BOLD})
	form.addIntbox(sAltCapacity,0,10000,0,0,25,acChanged, {font=FONT_BOLD})
	form.addRow(2)
	form.addLabel({label="Toggle Alt Accu", font=FONT_BOLD})
	form.addInputbox(sAccuSwitch,true,asChanged, {font=FONT_BOLD})
	form.addLabel({label="  --> Toggle Switch recommended", font=FONT_MINI})
end
--------------------------------------------------------------------------------
-- Init
local function init()
	system.registerForm(1,MENU_MAIN,appName,initForm , nil,printForm)
	system.registerTelemetry(1,"Calc Capacity v2.0",2,printTelem)
	-- Saved Items
	sAcType = system.pLoad("sAcType",1 )				-- Which AC Type
	sThrustControl = system.pLoad("sThrustControl",nil)	-- Throttle (P4 for Mode 2), use Proportional!
	sCapacity = system.pLoad("sCapacity",-1)			-- Capacity mAh or mL
	sThrust100 = system.pLoad("sThrust100",-1)			-- Current Throttle 100%
	sThrust75 = system.pLoad("sThrust75",-1)			-- Current Throttle 75%
	sThrust50 = system.pLoad("sThrust50",-1)			-- Current Throttle 50%
	sThrust25 = system.pLoad("sThrust25",-1)			-- Current Throttle 25%
	sThrust00 = system.pLoad("sThrust00",0)				-- Current Throttle 0%
	sKnockOff = system.pLoad("sKnockOff",0)         	-- Prewarning
	sBingo = system.pLoad("sBingo",0)               	-- Final Warning
	sSafetySwitch = system.pLoad("sSafetySwitch")		-- Engine Safety Switch
	sResetSwitch = system.pLoad("sResetSwitch")			-- Reset capacity to 100%
	sMultFlight = system.pLoad("sMultFlight",2)			-- Value Stored for next Flight	
	--sCheckRec = system.pLoad("sCheckRec",5)			-- Check Receiver online (for future version)
	sReport = system.pLoad("sReport")               	-- Report actual Capacity
	sIntCap = system.pLoad("sIntCap",100)				-- Store Value for multiple Flights
	sAltCapacity = system.pLoad("sAltCapacity",0)		-- Capacity mAh or mL
	sAccuSwitch = system.pLoad("sAccuSwitch")			-- Switch to Alternate Accu 	
	sAltEn = system.pLoad("sAltEn",0)					-- 0 = primary Accu, 1 = alternate Accu
	collectgarbage()
end
--------------------------------------------------------------------------------
collectgarbage()
return {init=init, loop=loop, author="Walter Loetscher", version="v2.0", name = appName}
--------------------------------------------------------------------------------
